/** Rill v0.0.23 https://www.npmjs.com/package/rill License: MIT*/
var Application, Request, Response, chain, co, compose, hijack, http, parseDates, pathToReg,
  slice = [].slice;

co = require("co");

pathToReg = require("path-to-regexp");

compose = require("./util/compose");

parseDates = require("./util/parseDates");

Request = require("./request");

Response = require("./response");

{
  hijack = require("./hijackBrowser");
  chain = [];
}

Application = (function() {
  var j, len, method, ref;

  function Application() {
    if (!(this instanceof Application)) {
      return new Application();
    }
    this.middleware = [];
  }

  Application.prototype.listen = function() {
    var server;
    {
      hijack.onChange(this.callback());
      return hijack.listen();
    }
  };

  Application.prototype.callback = function() {
    var fn;
    fn = co.wrap(compose(chain.concat(this.middleware)));
    return function(req, res) {
      return fn(new Request(req), new Response(res))["catch"](function(err) {
        throw err;
      });
    };
  };

  Application.prototype.use = function() {
    var middlewares;
    middlewares = 1 <= arguments.length ? slice.call(arguments, 0) : [];
    this.middleware = this.middleware.concat(middlewares);
    return this;
  };

  ref = ["options", "head", "get", "put", "post", "delete"];
  for (j = 0, len = ref.length; j < len; j++) {
    method = ref[j];
    Application.prototype[method] = (function() {
      return function() {
        var keys, middlewares, path;
        path = arguments[0], middlewares = 2 <= arguments.length ? slice.call(arguments, 1) : [];
        keys = [];
        path = pathToReg(path, keys);
        middlewares = compose(middlewares);
        this.use(regeneratorRuntime.mark(function callee$3$0(req, res, next) {
          var i, k, len1, match, name;

          return regeneratorRuntime.wrap(function callee$3$0$(context$4$0) {
            while (1) switch (context$4$0.prev = context$4$0.next) {
            case 0:
              if (req.method === method && (match = req.pathname.match(path.regex))) {
                context$4$0.next = 2;
                break;
              }

              return context$4$0.abrupt("return");
            case 2:
              req.params = {};
              for (i = k = 0, len1 = keys.length; k < len1; i = ++k) {
                name = keys[i].name;
                req.params[name] = match[i + 1];
              }
              context$4$0.next = 6;
              return middlewares.call(this, req, res);
            case 6:
              return context$4$0.abrupt("return", context$4$0.sent);
            case 7:
            case "end":
              return context$4$0.stop();
            }
          }, callee$3$0, this);
        }));
        return this;
      };
    })();
  }

  return Application;

})();

module.exports = Application;
