event   = require("component-event")
urllite = require("urllite")

module.exports =
	listen: ->
		event.bind(window, "popstate", handlePop)
		event.bind(window, "submit", handleClick)
		event.bind(window, "click", handleClick)
		return

	stop: ->
		event.unbind(window, "popstate", handlePop)
		event.unbind(window, "submit", handleClick)
		event.unbind(window, "click", handleClick)
		return

	onChange: (cb)->
		callbacks.push(cb)
		return

	goTo: (url, { method, headers, title, replaceState } = {})->
		method ?= "GET"
		headers ?= {}
		title ?= ""
		url = urllite(url) if typeof url is "string"
		url.method = method
		url.headers = headers
		url.subdomains = (url.host || '').split('.').reverse().slice(2)

		window.history[if Boolean(replaceState) then "replaceState" else "pushState"](url, title, url.href)
		cb(url) for cb in callbacks
		return

{ handleClick, handlePop } = require("./handlers")
