isType     = require("./isType")
byteLength = require("./byteLength")
empty =
	204: true
	205: true
	304: true

module.exports = (req, res, next)->
	yield next

	response = res.originalRes
	return if response.headersSent

	if (empty[res.status])
		res.headers["Content-Type"] = undefined
		res.body = null

	else if isType.String(res.body)
		res.headers["Content-Type"] ?= "text/#{if /^\s*</.test(res.body) then "html" else "plain"}"

	else if isType.Object(res.body)
		res.headers["Content-Type"] ?= "application/json"
		res.body = JSON.stringify(res.body)

	else
		res.headers["Content-Type"] ?= "application/octet-stream"
		if res.body.length
			res.headers["Content-Length"] ?= res.body.length

		if isType.Stream(res.body)
			return res.body.pipe(response)

	res.headers["Content-Length"] ?= byteLength(res.body)
	response.writeHead(res.status, res.headers)
	response.end(unless "HEAD" is req.method then res.body)
